This utility will allow you to scan through an .EXE or .DLL file and view
all icons present.  Icons are not divided into icon groups, so you might
see multiple version of the same icon (these will be icons used for different
resolution devices).  By using the View Next button, the next icon will be
displayed and by using the View Prev button the previously view icon can
be brought back and displayed.

If the Save button is pressed, a filename may be entered and the currently
visible icon will be saved into a file with the .ICO format.  You will be
presented with a dialog box asking for a file name.  There will also be two
radio buttons, one asking if you'd like to save the icon group, another
asking if you'd like to save the individual icon.  While advancing through
the icons, you may have noticed that some icons have the same name or number.
These icons are called an icon group and, if the icon group radio button is
enabled, all of these icons will be stored in the same file.  Such icon group
files are used to adjust the icon for different devices.  Thus, using an icon
group file will display a different icon based on whether the computer has a
VGA, EGA, Monochrome, or CGA display.  All four of these device types will
not always be represented in a group, so don't worry if you only see one or
two icons with the same name or number.

If the Replace button is pressed, you will be presented with a dialog box
containing a list of all files with the .ICO extension in your current
directory.  By selecting any .ICO file in the list, or by changing directories
and selecting a .ICO file someplace else, you will replace the currently
viewed icon with the icon contained in the selected file.
NOTE: At this time, only files containing a single icon are supported and this
      icon must be in the exact same format as the icon being replaced.

This program was created as a quick way to view and maintain icons in some of
icon libraries (DLL's) available since the available tools (e.g. The Whitewater
and Edensoft Resource Toolkits) require somewhat more time to perform minor
functions such as this.  This should offer an easy way to quickly extract only
the icons that one wants and/or needs.  For more advanced manipulation
or for the editing of icons, I would suggest purchasing one of the two tools
mentioned previously.

NOTE: Due to radically different formats, Windows Version 2.1 icons can not
      be read by this utility.  Some programs may run under both Windows 2.1 and
      Windows 3.0.  An example of this is WinWord.  Icons in such programs are
      stored in Windows 2.1 format, and thus can not be read.

A similar version of this program exists (IconExt) that will only extract
icons, not replace them.  I plan to still distribute IconExt as a separate
application for use by those people who are distributing icon DLL's and
encourage such people to distribute IconExt with their DLL, with the
understanding that IconExt remains mine and people must register it
separatly in order to receive support or information on modifications.

If you find this program interesting and would like to hear about future
enhancements and/or tools please send $20 to:

   Patrick Deupree
   4500 Sojourn, #2606
   Addison, TX 75248

Please mail any comments you might have to the above address or send me
e-mail on CompuServe at user ID 76427,442.

Authors Note:

I've not put an "automatic" about box or timed registration reminder in this
program, the reason being I've always found such things annoying, most
people ignore them, and it's a waste of time to write the code that does
so.

I would also like to mention that I've created this program using a set of
tools that I would also consider selling (compiled library only, no
code).  The two code sets I've used are:

    listman: This is a data set manager that will allow variable length
             data items to be stored in a list and retrieved.  This data
             set manager does not create a new memory handle for each
             item it adds in the list and does not require Windows to be
             in standard or enhanced mode to use it.  At this time item
             deletion does not free associated memory, however there is
             a function to free all memory allocated to the list.

    resinfo: This currently contains five major functions.  One will read
             an exe file and contain a data set of all resources of a
             particular type (that type being fed in as an argument).
             Another will save a single icon as a .ICO file, given its
             DIB data and given it's icon file header.  There is also a
             function that will save an icon group.  In the reverse, there
             is a function to read a .ICO file and return its DIB data and
             icon file header.  The final function will write an icon to
             a .EXE file, using information contained within the data set
             returned from the first function.  I will also, probably, be
             moving the routines I've written to display the icon into
             this module.  This tool set uses the previously mentioned
             "listman" tool set.

In addition to these tool sets, I've created a DOS program that will extract
Icon, Bitmap, and Cursor resources from an executable or resource file and
will also display information on Dialog, Menu, and String entries (such
as name, and info on menu items and controls such as item width, item ID, and
item name).

The reason I mention these is that I would be interested in finding out how
many people would like these tools.  I make no promises as to the
availability of these tools as how much work I put into them depends on
how much interest there is.
